package searchDesign;

/**
*
* <p>Beschreibung: Data ist die abstrakte Basisklasse, auf der die
* spezialisierten Datentypen KeyData und DocumentData aufbauen,
* da beide in den gleichen Speicherstrukturen untergebracht
* werden sollen. </p>
* @version 1.0
*/

public abstract class Data implements java.io.Serializable{

  /**
    * getKey() gibt den Schlssel des jeweiligen Objektes zurck, bei KeyData
    * ist dies das Schlsselwort als String, bei DocumentData die ID als
    * Integer-Objekt.
    *
    * @return key - der Schlssel des Objektes
    */

 public abstract Object getKey();

 /**
  * Vergleichsfunktion, die einen Schlssel "other" erwartet,
  * also einen String bei KeyData- und einen Integer bei DocumentData-Objekten,
  * und durch den Rckgabewert anzeigt, ob dieser kleiner (<0), grer (>0) oder
  * gleich(==0) dem gespeicherten Schlssel ist.
  *
  * @param other Der Schlssel, mit dem verglichen wird
  * @return das Ergebnis des Vergleichs
  */
 public abstract int compareTo(Object other);

 /**
  * add wird beim Einfgen eines Data-Objektes in eine Direktzugriffsstruktur
  * benutzt, wenn in dieser bereits ein Objekt mit gleichem Schlssel
  * gespeichert ist. Falls es sich bei other um ein KeyData handelt,
  * werden die DocumentData akkumuliert. Falls es sich um ein DocumentData
  * handelt, werden die Positionen und Spaces akkumuliert.
  *
  * @param other das Objekt, das hinzugefuegt werden soll
  */
 public abstract void add(Object other);


}