package searchDesign;
/**
 *
 * <p>Beschreibung: Wird von den beiden alternativen Direktzugriffsstrukturen
 * StorageTable und StorageTree implementiert.</p>
 * @version 1.0
 */
public interface StorageInterface {

        /**
         * Erzeugt aus der Datenstruktur ein Array mit Data-Objekten und gibt
         * dieses zurck.
         *
         * @return Data-Array
         */
	public Data[] asDataArray();

	/**
         * Fgt newData in die Direktzugriffsstruktur ein. Fall der Key von
         * newData bereits darin enthalten ist, wird die Methode add von
         * Data aufgerufen.
         *
         * @param newData Das neu einzufgende Data-Objekt
         */
	public void put(Data newData);

        /**
         * Gibt den Wert von key zurck, oder null, wenn key nicht in der
         * Direktzugriffsstruktur enthalten ist
         *
         * @param key Der Schlssel, dessen Wert gesucht wird
         * @return Der Wert des gefundenen Schlssels
         */
	public Object get(Object key);

	/**
         * gibt die Anzahl der gespeicherten Keys zurck
         * @return die Anzahl der gespeicherten Keys
         */
	public int size();

}
